unit Unit1;

interface

uses
  JwaWinBase, JwaWinIoCtl, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, sSkinProvider, sSkinManager, StdCtrls, Buttons, sBitBtn, Math,
  ExtCtrls, sPanel, ComCtrls, ShellCtrls, ShellAPI, Registry, WavedImage,
  JvBaseDlg, JvSelectDirectory, JvBrowseFolder, JvComponent,
  JvCommonDialogD, JvDiskPrompt;

type
  TForm1 = class(TForm)
    sSkinManager1: TsSkinManager;
    sSkinProvider1: TsSkinProvider;
    sPanel1: TsPanel;
    sBitBtn1: TsBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    sPanel2: TsPanel;
    Label3: TLabel;
    sBitBtn2: TsBitBtn;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    sPanel3: TsPanel;
    Label6: TLabel;
    Label7: TLabel;
    Image3: TWavedImage;
    Image1: TWavedImage;
    Image2: TWavedImage;
    sPanel4: TsPanel;
    sBitBtn3: TsBitBtn;
    sBitBtn4: TsBitBtn;
    sBitBtn5: TsBitBtn;
    sBitBtn6: TsBitBtn;
    Timer1: TTimer;
    SaveDialog1: TSaveDialog;
    sPanel5: TsPanel;
    BtnDonate: TsBitBtn;
    Label5: TLabel;
    Label8: TLabel;
    sPanel6: TsPanel;
    Label9: TLabel;
    Label10: TLabel;
    WavedImage1: TWavedImage;
    sBitBtn7: TsBitBtn;
    JvBrowseForFolderDialog1: TJvBrowseForFolderDialog;
    procedure sBitBtn2Click(Sender: TObject);
    procedure sBitBtn1Click(Sender: TObject);
    procedure sBitBtn3Click(Sender: TObject);
    procedure sBitBtn6Click(Sender: TObject);
    procedure sBitBtn4Click(Sender: TObject);
    procedure sBitBtn5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtnDonateClick(Sender: TObject);
    procedure sBitBtn7Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    UninstallOK:string;
    InstallOK:string;
    InstallKO:string;
    RegCommand:string;
    Langue:string;
    HardDiskQuestion:string;
    TranslatedBy:string;
  end;

var
  Form1: TForm1;
  CurDir:string;

implementation

uses UnitsDialog, Unit3, Unit2, UnitChooseDrive, FileCtrl;

{$R *.dfm}
{$R Zipres.res}













function CalculerMemoire():integer;
var
  memory: TMemoryStatus;
  FreeMem:integer;
begin
  result:=128;
  try
    memory.dwLength := SizeOf(memory);
    GlobalMemoryStatus(memory);
    FreeMem:=memory.dwAvailPhys div 1024 div 1600;
    result:=Max(FreeMem,256);
    result:=Min(result,1024);
  except
  end;
end;




function GetAdminSid: PSID;
const
  // bekannte SIDs ... (WinNT.h)
  SECURITYNTAUTHORITY: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  // bekannte RIDs ... (WinNT.h)
  SECURITYBUILTINDOMAINRID: DWORD = $00000020;
  DOMAINALIASRIDADMINS: DWORD = $00000220;
begin
  Result := nil;
  AllocateAndInitializeSid(SECURITYNTAUTHORITY,
    2,
    SECURITYBUILTINDOMAINRID,
    DOMAINALIASRIDADMINS,
    0,
    0,
    0,
    0,
    0,
    0,
    Result);
end;

function IsAdmin: LongBool;
var
  TokenHandle: THandle;
  ReturnLength: DWORD;
  TokenInformation: PTokenGroups;
  AdminSid: PSID;
  Loop: Integer;
  wv: TOSVersionInfo;
begin
  wv.dwOSVersionInfoSize := sizeof(TOSversionInfo);
  GetVersionEx(wv);

  Result := (wv.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS);

  if (wv.dwPlatformId = VER_PLATFORM_WIN32_NT) then
  begin
    TokenHandle := 0;
    if OpenProcessToken(GetCurrentProcess, TOKEN_QUERY, TokenHandle) then
    try
      ReturnLength := 0;
      GetTokenInformation(TokenHandle, TokenGroups, nil, 0, ReturnLength);
      TokenInformation := GetMemory(ReturnLength);
      if Assigned(TokenInformation) then
      try
        if GetTokenInformation(TokenHandle, TokenGroups,
          TokenInformation, ReturnLength, ReturnLength) then
        begin
          AdminSid := GetAdminSid;
          for Loop := 0 to TokenInformation^.GroupCount - 1 do
          begin
            if EqualSid(TokenInformation^.Groups[Loop].Sid, AdminSid) then
            begin
              Result := True; break;
            end;
          end;
          FreeSid(AdminSid);
        end;
      finally
        FreeMemory(TokenInformation);
      end;
    finally
      CloseHandle(TokenHandle);
    end;
  end;
end; 





procedure Bui_ExecuteWait(Programme:string; Params:string; Showornot:integer);
var
  ShExecInfo : TShellExecuteInfo;
begin
  FillChar(ShExecInfo, SizeOf(ShExecInfo), 0);
  with ShExecInfo do
  begin
    cbSize := SizeOf(ShExecInfo);
    fMask  := SEE_MASK_NOCLOSEPROCESS;
    lpFile := PChar(Programme);
    lpVerb := 'open';
    lpParameters := PChar(Params);
    nShow  := Showornot;
  end;
  if ShellExecuteEx(@ShExecInfo) then
    WaitForSingleObject(ShExecInfo.hProcess, INFINITE);
end;


function Bui_TempRep():string;
var
  TempDir : array[0..MAX_PATH] of Char;
  nSize : DWord;
begin
  nSize:=SizeOf(TempDir);
  GetTempPath(nSize, @TempDir);
  result:=TempDir;
  if (result[length(result)]<>'\') then result:=result+'\';
end;




procedure decompresserFichier(Nom: string; Fichier: string);
var
  Zip:TResourceStream;
begin
  Zip:=TResourceStream.Create(Hinstance,Nom,'EXEFILE');
  Zip.SavetoFile(Fichier);
  Zip.Free;
end;



procedure SupprimerFichier(Fichier:string);
begin
  if FileExists(Fichier) then
  try
    DeleteFile(Fichier);
  except
  end;
end;



procedure extraireFichiers(Repertoire: string);
begin
  ChDir(PChar(Repertoire));
  decompresserFichier('MobaDrive_mlc', 'MobaDrive.mlc');
  decompresserFichier('bios_bin', 'bios.bin');
  decompresserFichier('libusb0_dll', 'libusb0.dll');
  decompresserFichier('fmod_dll', 'fmod.dll');
  decompresserFichier('kqemu_inf', 'kqemu.inf');
  decompresserFichier('kqemu_sys', 'kqemu.sys');
  decompresserFichier('qemu_exe', 'qemu.exe');
  decompresserFichier('SDL_dll', 'SDL.dll');
  decompresserFichier('vgabios_bin', 'vgabios.bin');
  decompresserFichier('vgabios_cirrus_bin', 'vgabios-cirrus.bin');
  if not DirectoryExists('keymaps') then
    MkDir('keymaps');
  ChDir('keymaps');
  decompresserFichier('fr', 'fr');
  decompresserFichier('modifiers', 'modifiers');
  decompresserFichier('common','common');
  decompresserFichier('ar','ar');
  decompresserFichier('da','da');
  decompresserFichier('de','de');
  decompresserFichier('dech','de-ch');
  decompresserFichier('engb','en-gb');
  decompresserFichier('enus','en-us');
  decompresserFichier('es','es');
  decompresserFichier('et','et');
  decompresserFichier('fi','fi');
  decompresserFichier('fo','fo');
  decompresserFichier('frbe','fr-be');
  decompresserFichier('frca','fr-ca');
  decompresserFichier('frch','fr-ch');
  decompresserFichier('hr','hr');
  decompresserFichier('hu','hu');
  decompresserFichier('is','is');
  decompresserFichier('it','it');
  decompresserFichier('ja','ja');
  decompresserFichier('lt','lt');
  decompresserFichier('lv','lv');
  decompresserFichier('mk','mk');
  decompresserFichier('nl','nl');
  decompresserFichier('nlbe','nl-be');
  decompresserFichier('no','no');
  decompresserFichier('pl','pl');
  decompresserFichier('pt','pt');
  decompresserFichier('ptbr','pt-br');
  decompresserFichier('ru','ru');
  decompresserFichier('sl','sl');
  decompresserFichier('sv','sv');
  decompresserFichier('th','th');
  decompresserFichier('tr','tr');
  ChDir(Repertoire);
end;




function Bui_TailleFichier(Fichier:string):integer;
var
  f: file of byte;
begin
  result:=0;
  try
    AssignFile(f, Fichier);
    Reset(f);
    result:=FileSize(f) div 1024;
    CloseFile(f);
  except
  end;
end;





function ExecAndWait(const FileName: string; const CmdShow: Integer): Longword;
var { by Pat Ritchey }
  zAppName: array[0..512] of Char;
  zCurDir: array[0..255] of Char;
  WorkDir: string;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
  AppIsRunning: DWORD;
begin
  StrPCopy(zAppName, FileName);
  GetDir(0, WorkDir);
  StrPCopy(zCurDir, WorkDir);
  FillChar(StartupInfo, SizeOf(StartupInfo), #0);
  StartupInfo.cb          := SizeOf(StartupInfo);
  StartupInfo.dwFlags     := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := CmdShow;
  if not CreateProcess(nil,
    zAppName, // pointer to command line string
    nil, // pointer to process security attributes
    nil, // pointer to thread security attributes
    False, // handle inheritance flag
    CREATE_NEW_CONSOLE or // creation flags
    NORMAL_PRIORITY_CLASS,
    nil, //pointer to new environment block
    nil, // pointer to current directory name
    StartupInfo, // pointer to STARTUPINFO
    ProcessInfo) // pointer to PROCESS_INF
    then Result := WAIT_FAILED
  else
  begin
    while WaitForSingleObject(ProcessInfo.hProcess, 0) = WAIT_TIMEOUT do
    begin
      Application.ProcessMessages;
      Sleep(50);
    end;
    WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
    GetExitCodeProcess(ProcessInfo.hProcess, Result);
    CloseHandle(ProcessInfo.hProcess);
    CloseHandle(ProcessInfo.hThread);
  end;
end; { WinExecAndWait32 }




function GetDeviceNumber(Drive : String) : Cardinal;
var R : LongBool;                  // retour de fonction
    HVolume : THandle;             // Hande du volume
    sdn : STORAGE_DEVICE_NUMBER;   // n du volume
    dw : DWORD;

   {Obtention du Handle du volume}
   function GetHVolume(Drive : String) : THandle;
   var CheminVolume : String;
   begin
    CheminVolume:='\\.\'+Drive;
    Result:=CreateFile(Pchar(CheminVolume), 0,
                     FILE_SHARE_READ OR FILE_SHARE_WRITE,
                     Nil, OPEN_EXISTING, 0, 0);
    end;
begin
 HVolume:=GetHVolume(Drive);
 R := JWAWinBase.DeviceIoControl(hVolume,
                     IOCTL_STORAGE_GET_DEVICE_NUMBER,
                     Nil, 0, @sdn, sizeof(sdn),
                     @dw, nil);
 if R then Result := sdn.DeviceNumber
      else begin
       result:=0;
      end;
 CloseHandle(HVolume);
end;




procedure SupprimerFichiers(Rep:string);
begin
  try
    SupprimerFichier(Rep+'MobaDrive.mlc');
    SupprimerFichier(Rep+'keymaps\fr');
    SupprimerFichier(Rep+'keymaps\modifiers');
    SupprimerFichier(Rep+'keymaps\ar');
    SupprimerFichier(Rep+'keymaps\common');
    SupprimerFichier(Rep+'keymaps\da');
    SupprimerFichier(Rep+'keymaps\de');
    SupprimerFichier(Rep+'keymaps\de-ch');
    SupprimerFichier(Rep+'keymaps\en-gb');
    SupprimerFichier(Rep+'keymaps\en-us');
    SupprimerFichier(Rep+'keymaps\es');
    SupprimerFichier(Rep+'keymaps\et');
    SupprimerFichier(Rep+'keymaps\fi');
    SupprimerFichier(Rep+'keymaps\fo');
    SupprimerFichier(Rep+'keymaps\fr-be');
    SupprimerFichier(Rep+'keymaps\fr-ca');
    SupprimerFichier(Rep+'keymaps\fr-ch');
    SupprimerFichier(Rep+'keymaps\hr');
    SupprimerFichier(Rep+'keymaps\hu');
    SupprimerFichier(Rep+'keymaps\is');
    SupprimerFichier(Rep+'keymaps\it');
    SupprimerFichier(Rep+'keymaps\ja');
    SupprimerFichier(Rep+'keymaps\lt');
    SupprimerFichier(Rep+'keymaps\lv');
    SupprimerFichier(Rep+'keymaps\mk');
    SupprimerFichier(Rep+'keymaps\nl');
    SupprimerFichier(Rep+'keymaps\nl-be');
    SupprimerFichier(Rep+'keymaps\no');
    SupprimerFichier(Rep+'keymaps\pl');
    SupprimerFichier(Rep+'keymaps\pt');
    SupprimerFichier(Rep+'keymaps\pt-br');
    SupprimerFichier(Rep+'keymaps\ru');
    SupprimerFichier(Rep+'keymaps\sl');
    SupprimerFichier(Rep+'keymaps\sv');
    SupprimerFichier(Rep+'keymaps\th');
    SupprimerFichier(Rep+'keymaps\tr');
    try
      RmDir(Rep+'keymaps');
    except
    end;
    SupprimerFichier(Rep+'vgabios-cirrus.bin');
    SupprimerFichier(Rep+'bios.bin');
    SupprimerFichier(Rep+'libusb0.dll');
    SupprimerFichier(Rep+'fmod.dll');
    SupprimerFichier(Rep+'kqemu.inf');
    SupprimerFichier(Rep+'kqemu.sys');
    SupprimerFichier(Rep+'qemu.exe');
    SupprimerFichier(Rep+'SDL.dll');
    SupprimerFichier(Rep+'vgabios.bin');
  except
  end;
end;



procedure TForm1.sBitBtn2Click(Sender: TObject);
var
  IsoFile:string;
  Partition:string;
  PhysicalDrive:string;
begin
  PhysicalDrive:='';
  if isAdmin then
  try
    Partition:=GetCurrentDir[1];
    Partition:=LowerCase(Partition);
    if DirectoryExists(Partition+':\') then
      PhysicalDrive:=' -hdb \\.\PhysicalDrive'+IntToStr(GetDeviceNumber(Partition+':'))+' ';
  except
  end;


  IsoFile:='';
  if ParamStr(1)<>'' then
    IsoFile:=ParamStr(1)
  else if OpenDialog1.Execute then
    IsoFile:=OpenDialog1.FileName;
  if not FileExists(IsoFile) then
    Exit;

    try
      ChDir(ExtractFilePath(IsoFile));
      CurDir:=GetCurrentDir;
    except
    end;
    if CurDir[length(CurDir)]<>'\' then
      CurDir:=CurDir+'\';
    ChDir(Bui_TempRep);
    extraireFichiers(Bui_TempRep);
    ChDir(Bui_TempRep);
    if IsAdmin then
    try
      Bui_ExecuteWait('net','stop kqemu',SW_HIDE);
    except
    end;

    sBitBtn2.Enabled:=false;
    sBitBtn7.Enabled:=false;
    ChDir(Bui_TempRep);
    if ((lowercase(ExtractFileExt(IsoFile))='.iso') or (lowercase(ExtractFileExt(IsoFile))='iso')) then
    begin
      if FormsDialog.ShowsDialog(HardDiskQuestion,'','',true) then
      begin
        if SaveDialog1.Execute then
        try
          CopyFile(PChar(Bui_TempRep+'MobaDrive.mlc'),PChar(SaveDialog1.FileName),false);
        except
        end;
      end;
    end;
    ChDir(Bui_TempRep);
    if IsAdmin then
    try
      ExecAndWait('rundll32.exe setupapi,InstallHinfSection DefaultInstall 132 .\kqemu.inf',SW_HIDE);
      ExecAndWait('net start kqemu',SW_HIDE);
    except
    end;
    if ((lowercase(ExtractFileExt(IsoFile))='.iso') or (lowercase(ExtractFileExt(IsoFile))='iso')) then
    begin
      if FileExists(SaveDialog1.FileName) then
        ExecAndWait('qemu.exe -boot d '+PhysicalDrive+' -cdrom "'+CurDir+ExtractFileName(IsoFile)+'" -m '+IntToStr(CalculerMemoire)+' -localtime -L . -hda "'+SaveDialog1.FileName+'" -net nic -net user -usb',SW_HIDE)
      else
        ExecAndWait('qemu.exe -boot d '+PhysicalDrive+' -cdrom "'+CurDir+ExtractFileName(IsoFile)+'" -m '+IntToStr(CalculerMemoire)+' -localtime -L . -net nic -net user -usb',SW_HIDE);
    end
    else
      ExecAndWait('qemu.exe -boot c '+PhysicalDrive+' -hda "'+CurDir+ExtractFileName(IsoFile)+'" -m '+IntToStr(CalculerMemoire)+' -localtime -L . -net nic -net user -usb',SW_HIDE);
    if IsAdmin then
    try
      ExecAndWait('net stop kqemu',SW_HIDE);
      ExecAndWait('rundll32.exe setupapi,InstallHinfSection Uninstall 132 .\kqemu.inf',SW_HIDE);
    except
    end;
    sBitBtn2.Enabled:=true;
    sBitBtn7.Enabled:=true;

    SupprimerFichiers(Bui_TempRep);
end;

procedure TForm1.sBitBtn1Click(Sender: TObject);
var
  Reg:TRegistry;
  PrecValeur:string;
begin
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand+'\command',true) then
    begin
      if Reg.ValueExists('SOFTWARE\CLASSES\.iso') then
        PrecValeur:=Reg.ReadString('SOFTWARE\CLASSES\.iso')
      else
        PrecValeur:='iso_auto_file';
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
  try
    Reg:=TRegistry.Create;
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\'+PrecValeur+'\Shell\'+RegCommand+'\command',true) then
    begin
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;

  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.mlc\Shell\'+RegCommand+'\command',true) then
    begin
      if Reg.ValueExists('SOFTWARE\CLASSES\.iso') then
        PrecValeur:=Reg.ReadString('SOFTWARE\CLASSES\.iso')
      else
        PrecValeur:='iso_auto_file';
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;
  try
    Reg:=TRegistry.Create;
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\'+PrecValeur+'\Shell\'+RegCommand+'\command',true) then
    begin
      Reg.WriteString('',ParamStr(0)+' "%1"');
      Reg.CloseKey;
    end;
  finally
    Reg.Free;
  end;

  FormsDialog.ShowsDialog(InstallOK,'','',false);
 except
   FormsDialog.ShowsDialog(InstallKO,'','',false);
 end;
end;

procedure TForm1.sBitBtn3Click(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.sBitBtn6Click(Sender: TObject);
var
  Reg:TRegistry;
begin
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD',true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD');
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\iso_auto_file\Shell\Emuler avec BuibuiLiveCD',true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\Emuler avec BuibuiLiveCD');
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand,true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand);
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 try
  Reg:=TRegistry.Create;
  try
    Reg.RootKey:=HKEY_LOCAL_MACHINE;
    if Reg.OpenKey('SOFTWARE\CLASSES\iso_auto_file\Shell\'+RegCommand,true) then
    begin
      Reg.CloseKey;
      Reg.DeleteKey('SOFTWARE\CLASSES\.iso\Shell\'+RegCommand);
    end;
  finally
    Reg.Free;
  end;
 except
 end;
 FormsDialog.ShowsDialog(UninstallOK,'','',false);
end;

procedure TForm1.sBitBtn4Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

procedure TForm1.sBitBtn5Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=false;
  if ParamStr(1)<>'' then
    sBitBtn2Click(sBitBtn2);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  UninstallOK:='MobaLiveCD a t supprim du menu contextuel des images ISO';
  InstallOK:='MobaLiveCD a t ajout au menu contextuel des images ISO';
  InstallKO:='Vous devez tre administrateur du PC pour effectuer cette action.';
  RegCommand:='Emuler avec MobaLiveCD';
  HardDiskQuestion:='Voulez-vous crer un disque dur pour votre machine virtuelle ?';
end;

procedure TForm1.BtnDonateClick(Sender: TObject);
begin
  if (Langue='fr') then
    ShellExecute(0,nil,PChar('http://www.mobatek.net/donate_fr.php'),nil,nil,SW_SHOW)
  else
    ShellExecute(0,nil,PChar('http://www.mobatek.net/donate_en.php'),nil,nil,SW_SHOW);
end;

procedure TForm1.sBitBtn7Click(Sender: TObject);
var
  Partition:string;
  PhysicalDrive:string;
begin
  if not IsAdmin then
  begin
    FormsDialog.ShowsDialog(InstallKO,'','',false);
    Exit;
  end;

  try
    FormChooseDrive.DriveComboBox1.TextCase:=FormChooseDrive.DriveComboBox1.TextCase;
  except
  end;

  if FormChooseDrive.ShowModal=mrOk then
  try

    PhysicalDrive:='';
    Partition:=FormChooseDrive.DriveComboBox1.Drive;
    Partition:=LowerCase(Partition);
    PhysicalDrive:=' -hda \\.\PhysicalDrive'+IntToStr(GetDeviceNumber(Partition+':'))+' ';

    ChDir(Bui_TempRep);
    extraireFichiers(Bui_TempRep);
    ChDir(Bui_TempRep);
    if IsAdmin then
    try
      Bui_ExecuteWait('net','stop kqemu',SW_HIDE);
    except
    end;

    sBitBtn2.Enabled:=false;
    sBitBtn7.Enabled:=false;
    ChDir(Bui_TempRep);
    if FormsDialog.ShowsDialog(HardDiskQuestion,'','',true) then
    begin
      if SaveDialog1.Execute then
      try
        CopyFile(PChar(Bui_TempRep+'MobaDrive.mlc'),PChar(SaveDialog1.FileName),false);
      except
      end;
    end;
    ChDir(Bui_TempRep);
    if IsAdmin then
    try
      ExecAndWait('rundll32.exe setupapi,InstallHinfSection DefaultInstall 132 .\kqemu.inf',SW_HIDE);
      ExecAndWait('net start kqemu',SW_HIDE);
    except
    end;
    if FileExists(SaveDialog1.FileName) then
      ExecAndWait('qemu.exe -boot c '+PhysicalDrive+' -m '+IntToStr(CalculerMemoire)+' -localtime -L . -hdb "'+SaveDialog1.FileName+'" -net nic -net user -usb',SW_HIDE)
    else
      ExecAndWait('qemu.exe -boot c '+PhysicalDrive+' -m '+IntToStr(CalculerMemoire)+' -localtime -L . -net nic -net user -usb',SW_HIDE);
    if IsAdmin then
    try
      ExecAndWait('net stop kqemu',SW_HIDE);
      ExecAndWait('rundll32.exe setupapi,InstallHinfSection Uninstall 132 .\kqemu.inf',SW_HIDE);
    except
    end;
    sBitBtn2.Enabled:=true;
    sBitBtn7.Enabled:=true;

    SupprimerFichiers(Bui_TempRep);
  except
  end;
end;

end.
